diff --git a/INSTALL b/INSTALL
index 74aebff697..26dec2cc83 100644
--- a/INSTALL
+++ b/INSTALL
@@ -451,15 +451,15 @@ build the GNU C Library:
 
    * GNU 'make' 4.0 or newer
 
-     As of relase time, GNU 'make' 4.2.1 is the newest verified to work
-     to build the GNU C Library.
+     As of relase time, GNU 'make' 4.3 is the newest verified to work to
+     build the GNU C Library.
 
    * GCC 6.2 or newer
 
      GCC 6.2 or higher is required.  In general it is recommended to use
      the newest version of the compiler that is known to work for
      building the GNU C Library, as newer compilers usually produce
-     better code.  As of release time, GCC 9.2.1 is the newest compiler
+     better code.  As of release time, GCC 10.2 is the newest compiler
      verified to work to build the GNU C Library.
 
      For PowerPC 64-bits little-endian (powerpc64le), a GCC version with
@@ -491,7 +491,7 @@ build the GNU C Library:
 
      You must use GNU 'binutils' (as and ld) to build the GNU C Library.
      No other assembler or linker has the necessary functionality at the
-     moment.  As of release time, GNU 'binutils' 2.32 is the newest
+     moment.  As of release time, GNU 'binutils' 2.35 is the newest
      verified to work to build the GNU C Library.
 
      ARC architecture needs 'binutils' 2.32 or higher for TLS related
@@ -503,7 +503,7 @@ build the GNU C Library:
      need this version of the 'texinfo' package.  Earlier versions do
      not understand all the tags used in the document, and the
      installation mechanism for the info files is not present or works
-     differently.  As of release time, 'texinfo' 6.6 is the newest
+     differently.  As of release time, 'texinfo' 6.7 is the newest
      verified to work to build the GNU C Library.
 
    * GNU 'awk' 3.1.2, or higher
@@ -511,13 +511,13 @@ build the GNU C Library:
      'awk' is used in several places to generate files.  Some 'gawk'
      extensions are used, including the 'asorti' function, which was
      introduced in version 3.1.2 of 'gawk'.  As of release time, 'gawk'
-     version 5.0.1 is the newest verified to work to build the GNU C
+     version 5.1 is the newest verified to work to build the GNU C
      Library.
 
    * GNU 'bison' 2.7 or later
 
      'bison' is used to generate the 'yacc' parser code in the 'intl'
-     subdirectory.  As of release time, 'bison' version 3.4.1 is the
+     subdirectory.  As of release time, 'bison' version 3.6.4 is the
      newest verified to work to build the GNU C Library.
 
    * Perl 5
@@ -531,12 +531,12 @@ build the GNU C Library:
 
      'Sed' is used in several places to generate files.  Most scripts
      work with any version of 'sed'.  As of release time, 'sed' version
-     4.5 is the newest verified to work to build the GNU C Library.
+     4.8 is the newest verified to work to build the GNU C Library.
 
    * Python 3.4 or later
 
      Python is required to build the GNU C Library.  As of release time,
-     Python 3.7.4 is the newest verified to work for building and
+     Python 3.8.3 is the newest verified to work for building and
      testing the GNU C Library.
 
    * PExpect 4.0
@@ -553,7 +553,7 @@ build the GNU C Library:
      use the pretty printers.  Notice that your system having Python
      available doesn't imply that GDB supports it, nor that your
      system's Python and GDB's have the same version.  As of release
-     time GNU 'debugger' 8.3 is the newest verified to work to test the
+     time GNU 'debugger' 9.2 is the newest verified to work to test the
      pretty printers.
 
      Unless Python, PExpect and GDB with Python support are present, the
@@ -569,7 +569,7 @@ and if you change any of the message translation files you will need
 
    * GNU 'gettext' 0.10.36 or later
 
-     As of release time, GNU 'gettext' version 0.19.8.1 is the newest
+     As of release time, GNU 'gettext' version 0.20.2 is the newest
      version verified to work to build the GNU C Library.
 
 You may also need these packages if you upgrade your source tree using
diff --git a/manual/install.texi b/manual/install.texi
index 5131422727..977f61dbb1 100644
--- a/manual/install.texi
+++ b/manual/install.texi
@@ -489,7 +489,7 @@ build @theglibc{}:
 @item
 GNU @code{make} 4.0 or newer
 
-As of relase time, GNU @code{make} 4.2.1 is the newest verified to work
+As of relase time, GNU @code{make} 4.3 is the newest verified to work
 to build @theglibc{}.
 
 @item
@@ -498,7 +498,7 @@ GCC 6.2 or newer
 GCC 6.2 or higher is required.  In general it is recommended to use
 the newest version of the compiler that is known to work for building
 @theglibc{}, as newer compilers usually produce better code.  As of
-release time, GCC 9.2.1 is the newest compiler verified to work to build
+release time, GCC 10.2 is the newest compiler verified to work to build
 @theglibc{}.
 
 For PowerPC 64-bits little-endian (powerpc64le), a GCC version with support
@@ -544,7 +544,7 @@ To correctly translate and install the Texinfo documentation you need
 this version of the @code{texinfo} package.  Earlier versions do not
 understand all the tags used in the document, and the installation
 mechanism for the info files is not present or works differently.
-As of release time, @code{texinfo} 6.6 is the newest verified to work
+As of release time, @code{texinfo} 6.7 is the newest verified to work
 to build @theglibc{}.
 
 @item
@@ -553,14 +553,14 @@ GNU @code{awk} 3.1.2, or higher
 @code{awk} is used in several places to generate files.
 Some @code{gawk} extensions are used, including the @code{asorti}
 function, which was introduced in version 3.1.2 of @code{gawk}.
-As of release time, @code{gawk} version 5.0.1 is the newest verified
+As of release time, @code{gawk} version 5.1 is the newest verified
 to work to build @theglibc{}.
 
 @item
 GNU @code{bison} 2.7 or later
 
 @code{bison} is used to generate the @code{yacc} parser code in the @file{intl}
-subdirectory.  As of release time, @code{bison} version 3.4.1 is the newest
+subdirectory.  As of release time, @code{bison} version 3.6.4 is the newest
 verified to work to build @theglibc{}.
 
 @item
@@ -576,13 +576,13 @@ GNU @code{sed} 3.02 or newer
 
 @code{Sed} is used in several places to generate files.  Most scripts work
 with any version of @code{sed}.  As of release time, @code{sed} version
-4.5 is the newest verified to work to build @theglibc{}.
+4.8 is the newest verified to work to build @theglibc{}.
 
 @item
 Python 3.4 or later
 
 Python is required to build @theglibc{}.  As of release time, Python
-3.7.4 is the newest verified to work for building and testing
+3.8.3 is the newest verified to work for building and testing
 @theglibc{}.
 
 @item PExpect 4.0
@@ -600,7 +600,7 @@ GDB itself needs to be configured with Python support in order to use
 the pretty printers.  Notice that your system having Python available
 doesn't imply that GDB supports it, nor that your system's Python and
 GDB's have the same version.  As of release time GNU @code{debugger}
-8.3 is the newest verified to work to test the pretty printers.
+9.2 is the newest verified to work to test the pretty printers.
 
 Unless Python, PExpect and GDB with Python support are present, the
 printer tests will report themselves as @code{UNSUPPORTED}.  Notice
@@ -623,7 +623,7 @@ and if you change any of the message translation files you will need
 @item
 GNU @code{gettext} 0.10.36 or later
 
-As of release time, GNU @code{gettext} version 0.19.8.1 is the newest
+As of release time, GNU @code{gettext} version 0.20.2 is the newest
 version verified to work to build @theglibc{}.
 @end itemize
 